Option Strict Off
Option Explicit On
Friend Class Sample0Form
	Inherits System.Windows.Forms.Form
	Private Declare Function InPortB Lib "ACCES32.dll"  Alias "VBInPortB"(ByVal Port As Integer) As Short
	Private Declare Function InPort Lib "ACCES32.dll"  Alias "VBInPort"(ByVal Port As Integer) As Short
	Private Declare Function OutPortB Lib "ACCES32.dll"  Alias "VBOutPortB"(ByVal Port As Integer, ByVal Value As Byte) As Short
	Private Declare Function OutPort Lib "ACCES32.dll"  Alias "VBOutPort"(ByVal Port As Integer, ByVal Value As Byte) As Short
	Public BaseAddress As Integer
	Public AIM32Addr As Integer
	Public CalSpace As Integer
	Public Ended As Integer
	Public Range As Integer
	Public Mode As Integer
	Public Gain As Double
	Public EEPROMReady As Boolean
	
	'UPGRADE_WARNING: Event EndOption.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub EndOption_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles EndOption.CheckedChanged
		If eventSender.Checked Then
			Dim Index As Short = EndOption.GetIndex(eventSender)
			Dim i As Short
			
			If Index = 0 Then
				Ended = 1
				Channel2Label.Visible = True
				Volts2Label.Visible = True
				For i = 16 To 31
					ChannelLabels(i).Visible = True
					VoltsLabels(i).Visible = True
				Next i
			ElseIf Index = 1 Then 
				Ended = 0
				Channel2Label.Visible = False
				Volts2Label.Visible = False
				For i = 16 To 31
					ChannelLabels(i).Visible = False
					VoltsLabels(i).Visible = False
				Next i
			End If
			Call OutPortB(AIM32Addr + 1, Ended + CalSpace + &H10s)
		End If
	End Sub
	
	Private Sub ExitButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitButton.Click
		End
	End Sub
	
	Private Sub Sample0Form_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		CalSpace = 0
		Ended = 1
		Range = 0
		Mode = 0
		Gain = 0.5
		EEPROMReady = False
		
		If (InPortB(&H61s) = &HAA55s) Then
			Call MsgBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", 0, "Warning")
		End If
	End Sub
	
	'UPGRADE_WARNING: Event GainComboBox.SelectedIndexChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub GainComboBox_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles GainComboBox.SelectedIndexChanged
		Gain = CDbl(GainComboBox.Text)
		If Gain = 0.5 Then
			Range = &H0s
		ElseIf Gain = 1 Then 
			Range = &H20s
		ElseIf Gain = 2 Then 
			Range = &H40s
		ElseIf Gain = 50 Then 
			Range = &H60s
		ElseIf Gain = 100 Then 
			Range = &H80s
		ElseIf Gain = 200 Then 
			Range = &HA0s
		End If
	End Sub
	
	Private Sub StartButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles StartButton.Click
		If TestTimer.Enabled = True Then
			TestTimer.Enabled = False
			StartButton.Text = "Start Test"
			BaseEdit.Enabled = True
			AIM32Edit.Enabled = True
		Else
			StartButton.Text = "Abort Test"
			BaseEdit.Enabled = False
			AIM32Edit.Enabled = False
			
			BaseAddress = CInt("&H" & BaseEdit.Text)
			AIM32Addr = CInt("&H" & AIM32Edit.Text)
			Call OutPort(AIM32Addr + 1, &H10s + Ended + CalSpace)
			TestTimer.Enabled = True
		End If '  end else
	End Sub
	
	Private Sub TestTimer_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles TestTimer.Tick
		Dim chan As Short
		Dim counts As Short
		Dim MaxChannels As Short
		Dim timeout As Integer
		Dim volts As Double
		
		If Ended = 0 Then
			MaxChannels = 16
		Else
			MaxChannels = 32
		End If
		
		For chan = 0 To MaxChannels - 1
			timeout = 65535
			Call OutPortB(AIM32Addr, chan + Range) ' write AIM-32 channel
			
			Do While (CheckForBusy(AIM32Addr + 1) And (timeout > 0))
				timeout = timeout - 1
			Loop 
			
			timeout = 65535
			Call OutPortB(BaseAddress + 2, 0) ' write channel
			
			Do While (Not (CheckForEOC(BaseAddress)) And (timeout > 0))
				timeout = timeout - 1
			Loop 
			If (timeout = 0) Then
				VoltsLabels(chan).Text = "A/D Timeout"
			Else
				counts = InPort(BaseAddress + 2)
				volts = (CShort(counts And &HFFFs) * 5# / Gain) / 4096#
				
				VoltsLabels(chan).Text = VB6.Format(volts, "##.########")
			End If '  end else
		Next chan '  end for chan
	End Sub
	
	Private Function CheckForEOC(ByVal Address As Short) As Boolean
		Dim EOCCheck As Byte
		
		EOCCheck = InPortB(Address)
		CheckForEOC = ((EOCCheck And &H80s) = &H80s)
	End Function '  end CheckForEOC
	
	Private Function CheckForBusy(ByRef Address As Short) As Boolean
		Dim BusyCheck As Byte
		
		BusyCheck = InPortB(Address)
		CheckForBusy = ((BusyCheck And &H40s) = &H40s)
	End Function
End Class